/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"

/* Global typedef */

/* Global define */
#define	ulong	unsigned long
#define	uint	unsigned int
#define	ushort	unsigned short
#define	uchar	unsigned char

#define	BIT0	GPIO_Pin_0
#define	BIT1	GPIO_Pin_1
#define	BIT2	GPIO_Pin_2
#define	BIT3	GPIO_Pin_3
#define	BIT4	GPIO_Pin_4
#define	BIT5	GPIO_Pin_5
#define	BIT6	GPIO_Pin_6
#define	BIT7	GPIO_Pin_7
#define	BIT8	GPIO_Pin_8
#define	BIT9	GPIO_Pin_9
#define	BIT10	GPIO_Pin_10
#define	BIT11	GPIO_Pin_11
#define	BIT12	GPIO_Pin_12
#define	BIT13	GPIO_Pin_13
#define	BIT14	GPIO_Pin_14
#define	BIT15	GPIO_Pin_15

#define		TEST1_H		GPIOA->BSHR = BIT3
#define		TEST1_L		GPIOA->BCR = BIT3
#define		TEST2_H		GPIOA->BSHR = BIT4
#define		TEST2_L		GPIOA->BCR = BIT4
#define		TEST3_H		GPIOA->BSHR = BIT5
#define		TEST3_L		GPIOA->BCR = BIT5
#define		TEST4_H		GPIOA->BSHR = BIT6
#define		TEST4_L		GPIOA->BCR = BIT6
#define		TEST5_H		GPIOA->BSHR = BIT7
#define		TEST5_L		GPIOA->BCR = BIT7
#define		TEST6_H		GPIOB->BSHR = BIT0
#define		TEST6_L		GPIOB->BCR = BIT0
#define		TEST7_H		GPIOB->BSHR = BIT1
#define		TEST7_L		GPIOB->BCR = BIT1
#define		EN_H		GPIOA->BSHR = BIT8
#define		EN_L		GPIOA->BCR = BIT8
#define		TEST9_H		GPIOA->BSHR = BIT10
#define		TEST9_L		GPIOA->BCR = BIT10
#define		TEST10_H	GPIOA->BSHR = BIT15
#define		TEST10_L	GPIOA->BCR = BIT15
#define		TEST11_H	GPIOB->BSHR = BIT3
#define		TEST11_L	GPIOB->BCR = BIT3
#define		TEST12_H	GPIOB->BSHR = BIT4
#define		TEST12_L	GPIOB->BCR = BIT4
#define		LRST_H		GPIOB->BSHR = BIT6
#define		LRST_L		GPIOB->BCR = BIT6
#define		TEST8_H		GPIOD->BSHR = BIT0
#define		TEST8_L		GPIOD->BCR = BIT0

#define		SW1_IN		(GPIOA->INDR & BIT9)
#define		SW2_IN		(GPIOD->INDR & BIT0)

#define		SCL_H		GPIOB->BSHR = BIT7
#define		SCL_L		GPIOB->BCR = BIT7
#define		SDA_H		GPIOB->BSHR = BIT5
#define		SDA_L		GPIOB->BCR = BIT5
#define		SDA_ISET	GPIOB->BSHR = BIT5
#define		SDA_IN		GPIOB->INDR & BIT5
#define		I2C_DLY		Delay_Us(2)
#define		TEST4_STATE	GPIOA->OUTDR & BIT6

/* Global Variable */

volatile int	timer1ms;

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */

void	init_gpio( void)
{
	GPIO_InitTypeDef	gpio_opp;
	GPIO_InitTypeDef	gpio_oc;
	GPIO_InitTypeDef	gpio_ip;
	GPIO_InitTypeDef	gpio_an;
	int					sp;

	sp = GPIO_Speed_10MHz;
    gpio_opp.GPIO_Speed = sp;
    gpio_oc.GPIO_Speed = sp;
    gpio_ip.GPIO_Speed = sp;
    gpio_an.GPIO_Speed = sp;

    gpio_opp.GPIO_Mode	= GPIO_Mode_Out_PP;
	gpio_oc.GPIO_Mode	= GPIO_Mode_Out_OD;
	gpio_ip.GPIO_Mode	= GPIO_Mode_IPU;
	gpio_an.GPIO_Mode	= GPIO_Mode_AIN;

	gpio_opp.GPIO_Pin	= BIT3;		GPIO_Init( GPIOA, &gpio_opp);	// PA3	TEST1
    gpio_opp.GPIO_Pin	= BIT4;		GPIO_Init( GPIOA, &gpio_opp);	// PA4	TEST2
    gpio_opp.GPIO_Pin	= BIT5;		GPIO_Init( GPIOA, &gpio_opp);	// PA5	TEST3
    gpio_opp.GPIO_Pin	= BIT6;		GPIO_Init( GPIOA, &gpio_opp);	// PA6	TEST4
    gpio_opp.GPIO_Pin	= BIT7;		GPIO_Init( GPIOA, &gpio_opp);	// PA7	TEST5
    gpio_opp.GPIO_Pin	= BIT8;		GPIO_Init( GPIOA, &gpio_opp);	// PA8	EN
    gpio_opp.GPIO_Pin	= BIT10;	GPIO_Init( GPIOA, &gpio_opp);	// PA8	TEST9
    gpio_opp.GPIO_Pin	= BIT15;	GPIO_Init( GPIOA, &gpio_opp);	// PA8	TEST10
    gpio_opp.GPIO_Pin	= BIT0;		GPIO_Init( GPIOB, &gpio_opp);	// PB0	TEST6
    gpio_opp.GPIO_Pin	= BIT1;		GPIO_Init( GPIOB, &gpio_opp);	// PB0	TEST7
    gpio_opp.GPIO_Pin	= BIT3;		GPIO_Init( GPIOB, &gpio_opp);	// PB0	TEST11
    gpio_opp.GPIO_Pin	= BIT4;		GPIO_Init( GPIOB, &gpio_opp);	// PB0	TEST12
    gpio_opp.GPIO_Pin	= BIT6;		GPIO_Init( GPIOB, &gpio_opp);	// PB6	LRST

    gpio_oc.GPIO_Pin	= BIT7;		GPIO_Init( GPIOB, &gpio_oc);	// PB7	SCL
    gpio_oc.GPIO_Pin	= BIT5;		GPIO_Init( GPIOB, &gpio_oc);	// PB5	SDA

    gpio_ip.GPIO_Pin	= BIT9;		GPIO_Init( GPIOA, &gpio_ip);	// PA9	SW1

    GPIO_PinRemapConfig( GPIO_Remap_PD01, ENABLE);					// PD01 remap!
    gpio_ip.GPIO_Pin	= BIT0; 	GPIO_Init( GPIOD, &gpio_ip);	// PD0	SW2

    gpio_an.GPIO_Pin	= BIT0; 	GPIO_Init( GPIOA, &gpio_an);	// PA0	VOUT
    gpio_an.GPIO_Pin	= BIT1; 	GPIO_Init( GPIOA, &gpio_an);	// PA1	IOUT
    gpio_an.GPIO_Pin	= BIT2; 	GPIO_Init( GPIOA, &gpio_an);	// PA2	TH
}

void	init_nvic( int irqn, int pp, int sp)
{
	NVIC_InitTypeDef NVIC_InitStructure={ 0};
	NVIC_InitStructure.NVIC_IRQChannel 						= irqn ;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority 	= pp;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority 			= sp;
	NVIC_InitStructure.NVIC_IRQChannelCmd 					= ENABLE;
	NVIC_Init( &NVIC_InitStructure);
}

void	init_tim1( void)
{
	TIM_TimeBaseInitTypeDef	tim;

	RCC_APB2PeriphClockCmd( RCC_APB2Periph_TIM1, ENABLE );

	tim.TIM_ClockDivision		= TIM_CKD_DIV1;
	tim.TIM_CounterMode			= TIM_CounterMode_Down;
	tim.TIM_Period				= SystemCoreClock/1000;	// 1ms
	tim.TIM_Prescaler			= 0;
	tim.TIM_RepetitionCounter	= 0;
	TIM_TimeBaseInit( TIM1, &tim);
	TIM_ITConfig( TIM1, TIM_IT_Update, ENABLE);
	TIM_ARRPreloadConfig( TIM1, ENABLE);
 	TIM_Cmd( TIM1, ENABLE);
    init_nvic( TIM1_UP_IRQn, 1, 2);
}

void TIM1_UP_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void	TIM1_UP_IRQHandler( void)
{
	timer1ms++;
	TIM_ClearFlag( TIM1, TIM_FLAG_Update);
}

void	wait1ms( int delay)
{
	timer1ms = 0;
	while( timer1ms < delay);
}

void	i2c_start( void)
{
	SCL_H;
  	I2C_DLY;
	SDA_H;
  	I2C_DLY;
	SDA_L;
  	I2C_DLY;
	SCL_L;
}

void	i2c_end( void)
{
	SCL_L;
  	I2C_DLY;
	SDA_L;
  	I2C_DLY;
	SCL_H;
  	I2C_DLY;
	SDA_H;
}


char	i2c_out( char d)
{
	uchar	bit;
	char	i;
	char	r;

	bit	= 0x80;
	for( i = 0 ; i < 8 ; i++){
		if( d & bit){
			SDA_H;
		} else {
			SDA_L;
		}
      	I2C_DLY;
		SCL_H;
      	I2C_DLY;
		SCL_L;
		bit	= bit >> 1;
	}
	SDA_ISET;
  	I2C_DLY;
	SCL_H;
  	I2C_DLY;
	r = SDA_IN;
  	I2C_DLY;
	SCL_L;
  	I2C_DLY;
	SDA_L;
	return r;
}

char	i2c_in( char ack)
{
	uchar	bit;
	char	i;
	char	d;

	d = 0;
	SDA_ISET;
  	I2C_DLY;
	bit	= 0x80;
	for( i = 0 ; i < 8 ; i++){
		SCL_L;
      	I2C_DLY;
		if( SDA_IN) d |= bit;
      	I2C_DLY;
		SCL_H;
      	I2C_DLY;
		SCL_L;
      	I2C_DLY;
		bit	= bit >> 1;
	}
	if( ack){
		SCL_L;
	} else {
		SDA_H;
	}
  	I2C_DLY;
	SCL_H;
  	I2C_DLY;
	SCL_L;
  	I2C_DLY;
	SDA_L;
	return d;
}

void	init_i2c( void)
{
	i2c_end();
}

#define LCD_ADRS	0x7c

const	char	lcd_code[ 9] = { 0x38, 0x39, 0x14, 0x70, 0x56, 0x6c, 0x38, 0x0c, 0x01};

void	lcd_command( char d)
{
	i2c_start();
	i2c_out( LCD_ADRS);
	i2c_out( 0x00);
	i2c_out( d);
	i2c_end();
}

void	init_lcd( void)
{
	int i;

	SCL_H;
 	I2C_DLY;
	SDA_H;
 	I2C_DLY;
	LRST_L;
	wait1ms( 10);
	LRST_H;
	wait1ms( 10);
	for( i = 0 ; i < sizeof( lcd_code); i++){
		lcd_command( lcd_code[ i]);
	 	I2C_DLY;
	}
}

void	lcd_cursol_off( void)
{
	lcd_command( 0x0c);
}

void	lcd_cursol( char x, char y)
{
	unsigned char adr;

	adr = x;
	if( y){
		adr |= 0x40;
	}
	i2c_start();
	i2c_out( LCD_ADRS);
	i2c_out( 0x80);
	i2c_out( adr);
	i2c_end();
	lcd_command( 0x0f);
}

void	lcd_string( char x, char y, char *p)
{
	unsigned char len, i;
	unsigned char adr;

	for( i = 0 ; i < 8 ; i++){
		if( p[ i] == 0){
			break;
		}
	}
	len = i;
	adr = x;
	if( y){
		adr |= 0x40;
	}
	i2c_start();
	i2c_out( LCD_ADRS);
	i2c_out( 0x80);
	i2c_out( adr | 0x80);
	for( i = 0; i < ( len -1); i++){
		i2c_out( 0xc0);
		i2c_out(p[ i]);
	}
	i2c_out( 0x40);
	i2c_out(p[ i]);
	i2c_end();
}

int	get_sw( void)
{
	int	ret;

	ret = 0;
	if( SW1_IN == 0) ret |= 1;
	if( SW2_IN == 0) ret |= 2;
	return ret;
}

ADC_TypeDef	*pAD;

int	init_ad( void)
{
	ADC_InitTypeDef	ad;

	RCC_APB2PeriphClockCmd( RCC_APB2Periph_ADC1, ENABLE);

	pAD = ADC1;
	ad.ADC_Mode					= ADC_Mode_Independent;
	ad.ADC_DataAlign			= ADC_DataAlign_Right;
	ad.ADC_ExternalTrigConv		= ADC_ExternalTrigConv_None;
	ad.ADC_ContinuousConvMode	= DISABLE;
	ad.ADC_OutputBuffer			= ADC_OutputBuffer_Disable;
	ad.ADC_Pga					= ADC_Pga_1;
	ad.ADC_ScanConvMode			= DISABLE;
	ad.ADC_NbrOfChannel			= 1;
	ADC_Init( pAD, &ad);
	ADC_Cmd( pAD, ENABLE);
//	ADC_DiscModeChannelCountConfig( pAD, 3);
//	ADC_ITConfig( pAD, ADC_IT_EOC, ENABLE);
//	init_nvic( ADC_IRQn, 1, 2);
}
/*
void ADC1_2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
volatile int	ad_no;
volatile int	ad_buf[ 3];

void	ADC1_2_IRQHandler( void)
{
	ADC_ClearFlag( pAD, ADC_FLAG_EOC);
	ad_buf[ ad_no++] = ADC_GetConversionValue( pAD);
}
*/
int	get_ad( int ch)
{
	ADC_RegularChannelConfig( pAD, ch, 1, ADC_SampleTime_13Cycles5);
	ADC_SoftwareStartConvCmd( pAD, ENABLE);
	while( ADC_GetFlagStatus( pAD, ADC_FLAG_EOC) == RESET);
	return ADC_GetConversionValue( pAD);
}

int main(void)
{
	char	b[ 9];
	int		mode;

	mode = 0;
	NVIC_PriorityGroupConfig( NVIC_PriorityGroup_2);
    Delay_Init();

    GPIO_IPD_Unused();
    init_gpio();
    init_tim1();
    init_i2c();
    wait1ms( 5);
    init_lcd();
    init_ad();
    wait1ms( 5);
    lcd_string( 0, 0, "ATHC----");
    sprintf( b, "%3dMHz", SystemCoreClock/1000000);
    lcd_string( 0, 1, b);
    wait1ms( 1000);
    if( mode){
		lcd_string( 0, 0, "- O N - ");	EN_H;
    } else {
		lcd_string( 0, 0, "- OFF - ");	EN_L;
    }
    sprintf(b, "%08X", ADC1->RSQR3);
    lcd_string( 0, 1, b);
    while(1)
    {
     	sprintf( b, "%4d%4d", get_ad(ADC_Channel_0)/10, get_ad( ADC_Channel_2)/10);
    	lcd_string( 0, 1, b);
    	if( get_sw() == 1){
    		wait1ms( 20);
    		if( get_sw() == 1){
    			lcd_string( 0, 0, "- O N - ");
    			mode = 1;
    			EN_H;
    			wait1ms( 500);
    		}
    	} else if( get_sw() == 2){
    		wait1ms( 20);
    		if( get_sw() == 2){
    			mode = 0;
    			EN_L;
    			lcd_string( 0, 0, "- OFF - ");
    			wait1ms( 500);
    		}
    	}
   }
}
